﻿using System;
using System.Windows.Forms;

using Com.Piwigo.Lib.DTO;
using System.Collections.Generic;
using Com.Piwigo.Uploader.DTO;
using Com.Piwigo.Uploader.Service;
using Com.Piwigo.Uploader.Helper;

using System.IO;

namespace Com.Piwigo.Uploader
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string[] args = Environment.GetCommandLineArgs();

            foreach (string arg in args)
            {
                if (Directory.Exists(arg))
                {
                    try
                    {
                        ModelManager.Instance.directoryName = arg;
                        ServiceFactory.GetByType<LoadFromDirectory>().runService();
                    }
                    catch (ApplicationException aex)
                    {
                        MainAppHelper.showdErrorMessageBox(aex);
                    }
                }                    
            }
        }


        private void Connect_Click(object sender, EventArgs e)
        {
            try
            {
                String strUri= tbServer.Text.Replace("\\","/");
                if (!strUri.EndsWith("/ws.php"))
                {
                    if (!strUri.EndsWith("/"))
                    {
                        strUri += "/";
                    }
                    strUri += "ws.php";
                }

                Uri uriServeur;
                if (Uri.TryCreate(strUri, UriKind.Absolute,out uriServeur))
                {
                    ModelManager.Instance.serveurName = uriServeur;
                    ModelManager.Instance.userName = tbUser.Text;
                    ModelManager.Instance.password = tbPassword.Text;

                    ServiceFactory.GetByType<Connect>().runService();
                }

            }
            catch (ApplicationException aex)
            {
                MainAppHelper.showdErrorMessageBox(aex);
            }
        }

        private void Telecharger_Click(object sender, EventArgs e)
        {
            try
            {

                Int32 newid = 0;
                String msg = String.Empty;
                Boolean rc;
                // rc = PwgServiceProvider.Instance.PwgCategoriesService.AddCategory("test_cat", 1, ref  newid, ref msg);
                //List<PwgCategory> lstCat = PwgServiceProvider.Instance.PwgCategoriesService.GetAdminListOfCategory(); 
                //Console.WriteLine(String.Format("newid : {0} message : {1}", newid,msg));
                //rc = PwgServiceProvider.Instance.PwgCategoriesService.UpdateCategoryInfo(newid, "test2", "rename cat");
                //Boolean rc = PwgServiceProvider.Instance.PwgCategoriesService.DeleteCategory(newid, sess.SecurityToken, PwgCategoryPhotoDeletionModeEnum.None);
                //rc = PwgServiceProvider.Instance.PwgCategoriesService.MoveCategory(new List<Int32>() { newid }, PwgCategory.RootCategoryId, sess.SecurityToken);

                //lstCat = PwgServiceProvider.Instance.PwgCategoriesService.GetAdminListOfCategory(); 

                //FileInfo fiBig = new FileInfo("C:\\Users\\bayral\\Downloads\\49133_1636405570_2648232_n.jpg");
                //FileInfo fiThumb = new FileInfo(MakeThumb(fiBig, "C:\\Users\\bayral\\Downloads\\49133_1636405570_2648232_n_thum.jpg", 64));
                //FileInfo fiLow = new FileInfo(MakeThumb(fiBig, "C:\\Users\\bayral\\Downloads\\49133_1636405570_2648232_n_low.jpg", 256));

                //FileInfo fiBig = new FileInfo("C:\\temp\\Oryx.jpg");
                //FileInfo fiThumb = new FileInfo(MakeThumb(fiBig, "C:\\temp\\Oryx_thumb.jpg", 64));
                //FileInfo fiLow = new FileInfo(MakeThumb(fiBig, "C:\\temp\\Oryx_low.jpg", 256));

                //PwgImageAdded imgAdd = PwgServiceProvider.Instance.PwgImagesService.addImageByMultiPartForm(fiBig, null, 1, "benoit", "byarl", "test upload", 0, new List<PwgTag>() { new PwgTag() { Name = "Benoit" }, new PwgTag() { Name = "Noé" } });
                //rc = PwgServiceProvider.Instance.PwgImagesService.addImage(fiBig, fiLow, fiThumb, "Benoit", "bayral", DateTime.Now, "demo", new List<string>() { "1" }, new List<string>() { "Benoit" }, PwgConfidentLevelEnum.All);
                //rc = PwgServiceProvider.Instance.PwgImagesService.DeleteImage(319, sess.SecurityToken);

                //PwgImageInfo info = PwgServiceProvider.Instance.PwgImagesService.getImageInfo(imgAdd.Id, null, null);

                //PwgImageRate imgRate = PwgServiceProvider.Instance.PwgImagesService.RateImage(1, 5);


            }
            catch (ApplicationException aex)
            {
                MainAppHelper.showdErrorMessageBox(aex);
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
                ServiceFactory.GetByType<Disconnect>().runService();
            }
            catch (ApplicationException aex)
            {
                MainAppHelper.showdErrorMessageBox(aex);
            }
        }

        private void modelManagerBindingSource_CurrentChanged(object sender, EventArgs e)
        {

        }        
    }
}
